#ifndef T443_OBJECT_H
#define T443_OBJECT_H

#include "GeneralInclude.h"
			// help define the general stuff we will need for 
			// this project (e.g. iostream, define M_PI, etc.)
			//
#include "T2dBound.h"
			// This is a 2d bound
	

	//
	// The graphics objects we see on the screen, each is a "443Object"
	// a 443Object only has 4 behavior that we need:
	// 
	// 	1. DrawSelf:            
	// 					draws the geometry of this object on the display
	//
	//  2. SetToExpired:
	//					results in this object being deleted next time around.
	//
	//
	// 	3. WorldSpaceBound:     
	// 				returns a T2dBound for the object in the world
	//
	// 	4. IntersectsWithObject: 
	// 				test to see if this object intersect with the input
	// 	
	//



class T443Object {
	protected:
	public:

		T443Object() {}
		virtual ~T443Object() {}

		virtual void DrawSelf() = 0;
				//
				// will draw the geometry of this object on the display
				//
				
		virtual void SetToExpired() = 0;
				//
				// Signals this object should not be drawn the next time
				//

		virtual	void WorldSpaceBound(T2dBound &wcBound) = 0;
				//
				// compute and returns the 2d bound of this object
				//

		        bool IntersectsWithObject(T443Object*);
				//
				// We _MUST_ use this function for all our object-to-object
				// intersection computation. This function is implemented for
				// you. You should just use it. 
				// 
				// REMEMBER: YOU MUST use this function for mp2 and mp3 when it is
				// 			 time to test for interestion between two objects
				// 			 
				// 		*** FOR THE PURPOSE OF THIS CSS443:
				// 				You *CANNOT* comptue object-to-object intersections
				// 				by obtaiing the T2dBound from two different objects
				// 				and compute for object intersection by intersecting
				// 				the T2dBounds. Although this algorithm is correct,
				// 				for the timing purposes	you _CANNOT_ do this for our
				// 				mps. Plesae call the above IntersectsWithObject()
				// 				function instead.
		
};


//
// You DO NOT need to implement any of the above methods. In your programming assignments
// you will _USE_ these methods to implement the required functionality. As far as you
// are concerned, all the above methods are implemented by software engineers 
// working for you and they did a good job that these methods do not have any bugs.
// 
//

#endif
